<script setup lang="ts">
import { onMounted, ref } from 'vue'
import {
  selectedUid,
  selectedUp3Ulp,
  selectedUlp,
  fetchUid,
  itemsUid,
  itemsUp3,
  itemsUlp
} from './reference'
import Select from '@/components/Select.vue'
import DatePicker from '@/components/DatePicker.vue'
import InputWithSuffix from '@/components/Form/InputWithSuffix.vue'
const totalMin = ref("1 Menit")
const totalMax = ref("5 Menit")
const setDataMin = (value: any) => totalMin.value = value
const setDataMax = (value: any) => totalMax.value = value
const uidPlaceholder = 'Semua Unit Induk Distribusi/Wilayah'
const up3Placeholder = 'Semua Unit Pelaksanaan Pelayanan Pelanggan'
const ulpPlaceholder = 'Semua Unit Layanan Pelanggan'
const up3 = ref({ id: 0, name: up3Placeholder })
const uid = ref({ id: 0, name: uidPlaceholder })
const ulp = ref({ id: 0, name: ulpPlaceholder })
const emit = defineEmits(['update:filters'])

const sla = [
  {
    id: 1,
    name: 'Dibawah  / Sesuai SLA (<= 45 menit)'
  },
  {
    id: 2,
    name: 'Melebihi SLA (> 45 menit)'
  }
]

const data = ref({
  uid: uid.value,
  up3: up3.value,
  ulp: ulp.value,
  periode: '',
  minTime: 1,
  maxTime: 1
})

const setUid = (value: any) => {
  uid.value = value
  selectedUid(value)
  up3.value = { id: 0, name: up3Placeholder }
  data.value.uid = value
}

const setUp3 = (value: any) => {
  up3.value = value
  selectedUp3Ulp(value)
  ulp.value = { id: 0, name: ulpPlaceholder }
  data.value.up3 = value
}

const setUlp = (value: any) => {
  ulp.value = value
  selectedUlp(value)
  data.value.ulp = value
}

const setMin = (value: any) => {
  console.log(value)
  data.value.minTime = value
  setDataMin(value)
}

const setMax = (value: any) => {
  data.value.maxTime = value
  setDataMax(value)
}

const triggerInput = ref(false)
const changeDuration = (value: any) => {
  if (value.id === 0) {
    setMin('1')
    setMax('5')
    console.log('Durasi Menit')
    triggerInput.value = false
  } else if (value.id === 1) {
    setMin('1')
    setMax('45')
    console.log('Dibawah  / Sesuai SLA (<= 45 menit)')
    triggerInput.value = true
  } else {
    setMin('45')
    setMax(99999 * 60 * 24)
    triggerInput.value = true
    console.log('Melebihi SLA (> 45 menit)')
  }
}

onMounted(() => {
  emit('update:filters', data.value)
  fetchUid()
})
</script>

<template>
  <div class="grid grid-cols-1 gap-4 md:grid-cols-2">
    <div class="flex flex-col flex-1 space-y-2">
      <label class="filter-input-label">Unit Induk Distribusi/Wilayah:</label>

      <Select @update:selected="setUid($event)" :data="itemsUid" :placeholder="uidPlaceholder" />
    </div>

    <div class="flex flex-col flex-1 space-y-2">
      <label class="filter-input-label">Unit Pelaksanaan Pelayanan Pelanggan:</label>

      <Select @update:selected="setUp3($event)" :data="itemsUp3" :selected="up3" :placeholder="up3Placeholder" />
    </div>

    <div class="flex flex-col flex-1 space-y-2">
      <label class="filter-input-label">Unit Layanan Pelanggan:</label>

      <Select @update:selected="setUlp($event)" :data="itemsUlp" :placeholder="ulpPlaceholder" :selected="ulp" />
    </div>

    <div class="flex flex-col flex-1 space-y-2">
      <label class="filter-input-label">Periode Tanggal:</label>

      <DatePicker @update:date-value="(value) => (data.periode = value)" />
    </div>

    <div class="flex flex-col flex-1 space-y-2">
      <label class="filter-input-label">Durasi:</label>

      <div class="flex flex-col gap-y-2">
        <Select @update:selected="changeDuration($event)" :data="sla" placeholder="Durasi Menit" />
        <div class="flex flex-1 flex-row justify-between gap-x-1.5">
          <InputWithSuffix :value="`${data.minTime} Menit`" class="flex flex-1" />
          <small class="flex items-center">s/d</small>
          <InputWithSuffix :value="`${data.maxTime} Menit`" class="flex flex-1" />
        </div>
      </div>
    </div>
  </div>

</template>
